<?php /*

**************************************************************************

Plugin Name:  BBCode
Plugin URI:   http://www.viper007bond.com/wordpress-plugins/bbcode/
Description:  Implements <a href="http://en.wikipedia.org/wiki/BBCode">BBCode</a> in posts. Requires WordPress 2.5+ or WPMU 1.5+.
Version:      1.0.1
Author:       Viper007Bond
Author URI:   http://www.viper007bond.com/

**************************************************************************

Copyright (C) 2008 Viper007Bond

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************/

class BBCode {

	// Plugin initialization
	function BBCode() {
		// This version only supports WP 2.5+ (learn to upgrade please!)
		if ( !function_exists('add_shortcode') ) return;

		// Register the shortcodes
		add_shortcode( 'b'      , array(&$this, 'shortcode_bold'     ) );
		add_shortcode( 'i'      , array(&$this, 'shortcode_italics'  ) );
		add_shortcode( 'u'      , array(&$this, 'shortcode_underline') );
		add_shortcode( 'url'    , array(&$this, 'shortcode_url'      ) );
		add_shortcode( 'img'    , array(&$this, 'shortcode_image'    ) );
		add_shortcode( 'quote'  , array(&$this, 'shortcode_quote'    ) );

/**
 * @author Somik Khan
 * @copyright 2011
 */
        
        add_shortcode( 'list'   , array(&$this, 'shortcode_list'     ) );
        add_shortcode( 'center' , array(&$this, 'shortcode_center'   ) );
        add_shortcode( 'code'   , array(&$this, 'shortcode_code'     ) );
        
        add_shortcode( 'color'  , array(&$this, 'shortcode_color'    ) );
        add_shortcode( 'size'   , array(&$this, 'shortcode_size'     ) );
        add_shortcode( 'mail'   , array(&$this, 'shortcode_mail'     ) );
        
        
        
		add_shortcode( 'B'      , array(&$this, 'shortcode_bold'     ) );
		add_shortcode( 'I'      , array(&$this, 'shortcode_italics'  ) );
		add_shortcode( 'U'      , array(&$this, 'shortcode_underline') );
		add_shortcode( 'URL'    , array(&$this, 'shortcode_url'      ) );
		add_shortcode( 'IMG'    , array(&$this, 'shortcode_image'    ) );
		add_shortcode( 'QUOTE'  , array(&$this, 'shortcode_quote'    ) );
        
        add_shortcode( 'LIST'   , array(&$this, 'shortcode_list'     ) );
        add_shortcode( 'CENTER' , array(&$this, 'shortcode_center'   ) );
        add_shortcode( 'CODE'   , array(&$this, 'shortcode_code'     ) );
        
        add_shortcode( 'COLOR'  , array(&$this, 'shortcode_color'    ) );
        add_shortcode( 'SIZE'   , array(&$this, 'shortcode_size'     ) );
        add_shortcode( 'MAIL'   , array(&$this, 'shortcode_mail'     ) );        
        
	}


	// No-name attribute fixing
	function attributefix( $atts = array() ) {
		if ( empty($atts[0]) ) return $atts;

		if ( 0 !== preg_match( '#=("|\')(.*?)("|\')#', $atts[0], $match ) )
			$atts[0] = $match[2];

		return $atts;
	}


	// Bold shortcode
	function shortcode_bold( $atts = array(), $content = NULL ) {
		if ( NULL === $content ) return '';

		return '<strong>' . do_shortcode( $content ) . '</strong>';
	}


	// Italics shortcode
	function shortcode_italics( $atts = array(), $content = NULL ) {
		if ( NULL === $content ) return '';

		return '<em>' . do_shortcode( $content ) . '</em>';
	}


	// Underline shortcode
	function shortcode_underline( $atts = array(), $content = NULL ) {
		if ( NULL === $content ) return '';

		return '<span style="text-decoration:underline">' . do_shortcode( $content ) . '</span>';
	}


	// URL shortcode
	function shortcode_url( $atts = array(), $content = NULL ) {
		$atts = $this->attributefix( $atts );

		// [url="http://www.google.com/"]Google[/url]
		if ( isset($atts[0]) ) {
			$url = $atts[0];
			$text = $content;
		}
		// [url]http://www.google.com/[/url]
		else {
			$url = $text = $content;
		}

		if ( empty($url) ) return '';
		if ( empty($text) ) $text = $url;

		return '<a href="' . $url . '" rel="nofollow" target="_blank">' . do_shortcode( $text ) . '</a>';
	}


	// Image shortcode
	function shortcode_image( $atts = array(), $content = NULL ) {
		if ( NULL === $content ) return '';

		return '<img src="' . $content . '" alt="" />';
	}





/**
 * @author Somik Khan
 * @copyright 2011
 */




	// Quote shortcode
	function shortcode_quote( $atts = array(), $content = NULL ) {
		if ( NULL === $content ) return '';

		return '<blockquote>' . do_shortcode( $content ) . '</blockquote>';
	}


	// List shortcode
	function shortcode_list( $atts = array(), $content = NULL ) {
		if ( NULL === $content ) return '';

		return '<ul>' . do_shortcode( $content ) . '</ul>';
	}

	// Center shortcode
	function shortcode_center( $atts = array(), $content = NULL ) {
		if ( NULL === $content ) return '';

		return '<center>' . do_shortcode( $content ) . '</center>';
	}
    
    
	// Code shortcode
	function shortcode_code( $atts = array(), $content = NULL ) {
		if ( NULL === $content ) return '';

		return '<blockquote>' . do_shortcode( $content ) . '</blockquote>';
	}

	// Mail shortcode
	function shortcode_mail( $atts = array(), $content = NULL ) {
		$atts = $this->attributefix( $atts );

		// [url="http://www.google.com/"]Google[/url]
		if ( isset($atts[0]) ) {
			$url = $atts[0];
			$text = $content;
		}
		// [url]http://www.google.com/[/url]
		else {
			$url = $text = $content;
		}

		if ( empty($url) ) return '';
		if ( empty($text) ) $text = $url;

		return '<a href="mailto:' . $url . '" rel="nofollow" target="_blank">' . do_shortcode( $text ) . '</a>';
	}
    
	// Size shortcode
	function shortcode_size( $atts = array(), $content = NULL ) {
		$atts = $this->attributefix( $atts );

		// [size="3"]Google[/size]
		if ( isset($atts[0]) ) {
			$size = $atts[0] * 4;
			$text = $content;
		}

		if ( empty($size) ) return '';

		return '<span style="font-size:' . $size . ';">' . do_shortcode( $text ) . '</span>';
	}
    
	// Color shortcode
	function shortcode_color( $atts = array(), $content = NULL ) {
		$atts = $this->attributefix( $atts );

		// [size="3"]Google[/size]
		if ( isset($atts[0]) ) {
			$color = $atts[0];
			$text = $content;
		}

		if ( empty($color) ) return '';

		return '<span style="color:' . $color . ';">' . do_shortcode( $text ) . '</span>';
	}            
    
}

// Start this plugin once all other plugins are fully loaded
add_action( 'plugins_loaded', create_function( '', 'global $BBCode; $BBCode = new BBCode();' ) );

?>